EnableExplicit

XIncludeFile "MPFR.pbi"


Declare gauss_jordan ( Array a.mpfr(2), Array y.mpfr(1), Array coef.mpfr(1), ncol.l, prec.l, error_code.l)
Declare make_lanczos(Array x.mpfr(1), g.s, prec.i, ercode.i)

Define.mpfr mpfr_e, mpfr_pi, mpfr_zero, mpfr_one, mpfr_half
Define g.s, n.i

;main
;===========================================
;### set up n and g here ###
n = 6
g="5"
;----------
;n=14
;g="4.7421875"
;===========================================

OpenConsole()
Define.i i, error_code, digits_prec=20, bits_prec : bits_prec=8*n+digits_prec*10/3

Dim x.mpfr(n)
Define outb.s = Space(2000)
Define s.s 

For i=0 To n
    mpfr_init2(x(i), bits_prec)
Next
mpfr_init2(mpfr_e, bits_prec)
mpfr_init2(mpfr_pi, bits_prec)
mpfr_init2(mpfr_zero, bits_prec)
mpfr_init2(mpfr_one, bits_prec)
mpfr_init2(mpfr_half, bits_prec)
;-------------------------------
mpfr_set_ui(mpfr_zero, 0)
mpfr_set_ui(mpfr_one, 1)
mpfr_set_str(mpfr_half, "0.5", 10)
mpfr_exp(mpfr_e,mpfr_one)
mpfr_const_pi (mpfr_pi)

make_lanczos(x(), g, bits_prec, error_code)

If Not error_code
    CreateFile(0, "lanczos_gamma_"+Str(n)+".txt")
    For i=0 To n
        s="%"+Str(digits_prec+5)+"."+Str(digits_prec)+"RNe"
       mpfr_sprintf(outb, s, x(i))
       s=Str(i)
       If i<10 : s=" "+s : EndIf
       If Left(outb,1) <>"-" : outb=" "+outb : EndIf
       outb="C("+s+") = "+outb
       PrintN( outb)
       WriteString(0, outb+#CRLF$)
    Next
    CloseFile(0)
EndIf

For i=0 To n
    mpfr_clear(x(i))
Next
mpfr_clear(mpfr_e)
mpfr_clear(mpfr_pi)
mpfr_clear(mpfr_zero)
mpfr_clear(mpfr_one)
mpfr_clear(mpfr_half)

PrintN("press any key to exit ")
Input()
CloseConsole()
End

Procedure make_lanczos(Array x.mpfr(1), g_.s, bits_prec.i, error_code.i)
  Shared mpfr_e, mpfr_pi, mpfr_zero, mpfr_one, mpfr_half
  
    Define.l i, j
    Define.i sp, n = ArraySize(x())
    Dim a.mpfr(n, n)
    Dim b.mpfr(n)
    Define.mpfr g, tmp1, tmp2, tmp3, sqr2pi, mpfr_2_pi, fac
    
    For i=0 To n
       For j=0 To n
            mpfr_init2(a(i,j), bits_prec)
       Next
       mpfr_init2(b(i), bits_prec)
    Next

    mpfr_init2(g, bits_prec)
    mpfr_init2(tmp1, bits_prec)
    mpfr_init2(tmp2, bits_prec)
    mpfr_init2(tmp3, bits_prec)
    mpfr_init2(sqr2pi, bits_prec)
    mpfr_init2(mpfr_2_pi, bits_prec)
    mpfr_init2(fac, bits_prec)
    ;-------------------------------
    mpfr_mul_ui(mpfr_2_pi, mpfr_pi, 2)
    mpfr_sqrt(sqr2pi, mpfr_2_pi)
    mpfr_set_str(g, g_, 10)
    
    ;setup the matrix, for n=6 the matrix looks like this
    
    ; [[ 1,   1,   1/2, 1/3, 1/4,  1/5,  1/6 ] 
    ; [  1,   1/2, 1/3, 1/4, 1/5,  1/6,  1/7 ] 
    ; [  1,   1/3, 1/4, 1/5, 1/6,  1/7,  1/8 ] 
    ; [  1,   1/4, 1/5, 1/6, 1/7,  1/8,  1/9 ] 
    ; [  1.   1/5, 1/6, 1/7, 1/8,  1/9,  1/10 ] 
    ; [  1,   1/6, 1/7, 1/8, 1/9,  1/10, 1/11 ]
    ; [  1,   1/7, 1/8, 1/9, 1/10, 1/11, 1/12 ]] 

    For i=0 To n
      mpfr_set_ui(a(i,0), 1)
      For j=1 To n
        mpfr_set_ui(tmp1, i+j)
        mpfr_div(a(i,j), mpfr_one, tmp1)
      Next
    Next

    mpfr_set_ui(fac, 1)

    ;setup the constant terms, for n=6 and g=5 they are
    ;b( 0) =  41.62443691643906820752
    ;b( 1) =  16.01231640525168135809
    ;b( 2) =  9.36473553710404851170
    ;b( 3) =  6.57049625931606149987
    ;b( 4) =  5.09521672929646781312
    ;b( 5) =  4.20380175313001102196
    ;b( 6) =  3.61487381446333490266

    For i=0 To n
        If i>1
            mpfr_mul_ui(fac, fac, i)
        EndIf
        mpfr_add_ui(tmp1, mpfr_half, i)   ;tmp1=i+.5+g
        mpfr_add(tmp1, tmp1, g)
        
        mpfr_sqrt(tmp2, tmp1)            ;tmp2=(i+.5+g)^(i+.5) = sqrt(i+.5+g)*(i+.5+g)^i
        mpfr_pow_ui(tmp3, tmp1, i)
        mpfr_mul(tmp2, tmp2, tmp3)

        mpfr_exp (tmp3, tmp1)            ;tmp2=exp(i+.5+g)/(i+.5+g)^(i+.5)*i!
        mpfr_div(tmp1, tmp3, tmp2)
        mpfr_mul(tmp2, fac, tmp1)
        
        mpfr_div(b(i), tmp2, sqr2pi)    ;b(i)=exp(i+.5+g)/(i+.5+g)^(i+.5)*i!/sqr2pi
        ;mpfr_printf( !"%.20R*f\n", b(i) )
    Next

    ;now solve the system of linear equations, for n=6 and g=5 they are
    ; [[ 1,   1,   1/2, 1/3, 1/4,  1/5,  1/6 ]   =  41.62443691643906820752
    ; [  1,   1/2, 1/3, 1/4, 1/5,  1/6,  1/7 ]   =  16.01231640525168135809
    ; [  1,   1/3, 1/4, 1/5, 1/6,  1/7,  1/8 ]   =  9.36473553710404851170
    ; [  1,   1/4, 1/5, 1/6, 1/7,  1/8,  1/9 ]   =  6.57049625931606149987
    ; [  1.   1/5, 1/6, 1/7, 1/8,  1/9,  1/10 ]  =  5.09521672929646781312 
    ; [  1,   1/6, 1/7, 1/8, 1/9,  1/10, 1/11 ]  =  4.20380175313001102196
    ; [  1,   1/7, 1/8, 1/9, 1/10, 1/11, 1/12 ]] =  3.61487381446333490266
    
    ;and the solution for the above example is
    ;C(0) =     1.00000000019001482399
    ;C(1) =    76.18009172947146348309
    ;C(2) =   -86.50532032941676765250
    ;C(3) =    24.01409824083091049018
    ;C(4) =    -1.23173957245015538752
    ;C(5) =     0.00120865097386617851
    ;C(6) =    -0.00000539523938495313
    
    ;which is the Lanczos gamma function approximation
    ;as published in Numerical recipes

    gauss_jordan(a(), b(), x(), n, bits_prec, error_code)

    For i=0 To n
       For j=0 To n
          mpfr_clear(a(i,j))
       Next
       mpfr_clear(b(i))
    Next

    mpfr_clear(g)
    mpfr_clear(tmp1)
    mpfr_clear(tmp2)
    mpfr_clear(tmp3)
    mpfr_clear(sqr2pi)
    mpfr_clear(mpfr_2_pi)
    mpfr_clear(fac)
EndProcedure

Procedure gauss_jordan ( Array a.mpfr(2), Array y.mpfr(1), Array coef.mpfr(1), ncol.l, prec.l, error_code.l)

    ; matrix solution by Gaussian Elimination
  Shared mpfr_e, mpfr_pi, mpfr_zero, mpfr_one, mpfr_half
  Dim b.mpfr(ncol, ncol)
  Dim w.mpfr(ncol)               ; work array, ncol long

    Define.l i,j,i1,k,l,n
    Define.mpfr hold, sm, t, t2, t3, ab, big

    error_code=#False
    n=ncol
    
    mpfr_init2(hold,prec)
    mpfr_init2(sm,prec)
    mpfr_init2(t,prec)
    mpfr_init2(t2,prec)
    mpfr_init2(t3,prec)
    mpfr_init2(ab,prec)
    mpfr_init2(big,prec)
    
    For i=0 To n
        ; copy to work arrays
        For j=0 To n
            mpfr_init2(b(i,j),prec)
            mpfr_set(b(i,j),a(i,j))
        Next j
        mpfr_init2(w(i),prec)
        mpfr_set(w(i),y(i))
        mpfr_set(coef(i),mpfr_zero)
    Next
    For i=0 To n-1
        mpfr_abs(big,b(i,i))
        l=i
        i1=i+1
        For j=i1 To n
            ; search for largest element    
            mpfr_abs(ab,b(j,i))
            If mpfr_cmp(ab,big)>0
                mpfr_set(big,ab)
                l=j
            EndIf
        Next
        If mpfr_cmp(big,mpfr_zero)=0
            error_code= #True
        Else
            If l<>i
                ; interchange rows to put largest element on diagonal
                For j=0 To n
                    mpfr_set(hold,b(l,j))
                    mpfr_set(b(l,j),b(i,j))
                    mpfr_set(b(i,j),hold)
                Next
                mpfr_set(hold,w(l))
                mpfr_set(w(l),w(i))
                mpfr_set(w(i),hold)
            EndIf
            For j=i1 To n
                mpfr_div(t, b(j,i),b(i,i))
                For k=i1 To n
                    mpfr_mul(t2,t,b(i,k))
                    mpfr_set(t3,b(j,k))
                    mpfr_sub(b(j,k),t3,t2)
                Next
                mpfr_mul(t2,t,w(i))
                mpfr_set(t3,w(j))
                mpfr_sub(w(j),t3,t2)
            Next   ; j-loop
        EndIf   ; if big
    Next           ; i-loop
    If mpfr_cmp(b(n,n),mpfr_zero)=0
        error_code=#True
    Else
        mpfr_div(coef(n), w(n), b(n,n))
        i=n-1
        ; back substitution
        Repeat
            mpfr_set(Sm,mpfr_zero)
            For j=i To n
                mpfr_mul(t2, b(i,j), coef(j))
                mpfr_set(t3, sm)
                mpfr_add(Sm, t3, t2)
            Next
            mpfr_sub(t2, w(i), sm)
            mpfr_div(coef(i), t2, b(i,i))
            i=i-1
        Until i<0
    EndIf
    If error_code : PrintN( "ERROR: Matrix is singular"):EndIf
    For i=0 To n
       For j=0 To n
          mpfr_clear(b(i,j))
       Next
       mpfr_clear(w(i))
    Next
    mpfr_clear(hold)
    mpfr_clear(sm)
    mpfr_clear(t)
    mpfr_clear(t2)
    mpfr_clear(t3)
    mpfr_clear(ab)
    mpfr_clear(big)
EndProcedure
 
; IDE Options = PureBasic 5.31 (Windows - x64)
; CursorPosition = 18
; Folding = -
; EnableXP