Structure mpz Align #PB_Structure_AlignC ; multiprecision integer 
  mp_alloc.l 
  mp_size.l 
  mp_limb.i 
EndStructure 

Structure mpq Align #PB_Structure_AlignC ; multiprecision rational 
  mp_num.mpz 
  mp_den.mpz 
EndStructure 

Structure mpf Align #PB_Structure_AlignC ; multiprecision floating point 
  mp_prec.l 
  mp_size.l 
  mp_expt.i 
  mp_limb.i 
EndStructure 

Structure mpfr Align #PB_Structure_AlignC ; multiprecision floating point
  prec.i
  sign.l
  exp.i
  d.i
EndStructure


Structure gmp_randata_lc_t Align #PB_Structure_AlignC
  mp_a.i
  mp_c.i
  mp_m.i
  mp_m2exp.i
EndStructure

Structure mp_algdata_t Align #PB_Structure_AlignC
  StructureUnion
    *_mp_lc.gmp_randata_lc_t
  EndStructureUnion
EndStructure

Structure gmp_randstate_t Align #PB_Structure_AlignC
  mp_seed.mpz
  mp_alg.i
  mp_algdata.mp_algdata_t
EndStructure

#MPFR_RNDN   = 0 ;round to nearest
#MPFR_RNDZ   = 1 ;round towards zero
#MPFR_RNDU   = 2 ;round towards plus infinity
#MPFR_RNDD   = 3 ;round towards minus infinity
#MPFR_RNDA   = 4 ;round away from zero
#MPFR_RNDF   = 5 ;faithful rounding (not implemented yet)
#MPFR_RNDNA = -1 ;round to nearest, with ties away from zero (mpfr_round)

Define MPFRLibrary.i

MPFRLibrary = OpenLibrary(#PB_Any, "libmpfr-4.dll")

If MPFRLibrary
  PrototypeC   mpfr_init2 ( *x.mpfr, prec.i)
  PrototypeC   mpfr_clear ( *x.mpfr)
  PrototypeC   mpfr_init ( *x.mpfr)
  PrototypeC   mpfr_set_default_prec ( prec.i)
  PrototypeC.i mpfr_get_default_prec ()
  PrototypeC   mpfr_set_prec ( *x.mpfr, prec.i)
  PrototypeC.i mpfr_get_prec ( *x.mpfr)
  PrototypeC.l mpfr_set ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_set_ui ( *rop.mpfr, op.i, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_set_si ( *rop.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_set_flt ( *rop.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_set_d ( *rop.mpfr, op.d, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_set_z ( *rop.mpfr, *op.mpz, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_set_q ( *rop.mpfr, *op.mpq, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_set_f ( *rop.mpfr, *op.mpf, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_set_ui_2exp ( *rop.mpfr, op.i, e.i, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_set_si_2exp ( *rop.mpfr, e.i, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_set_z_2exp ( *rop.mpfr, *op.mpz, e.i, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_set_str ( *rop.mpfr, s.s, base.l, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_strtofr ( *rop.mpfr, *nptr, *endptr, base.l, rnd.l = #MPFR_RNDN)
  PrototypeC   mpfr_set_nan ( *x.mpfr)
  PrototypeC   mpfr_set_inf ( *x.mpfr, sign.l)
  PrototypeC   mpfr_set_zero ( *x.mpfr, sign.l)
  PrototypeC   mpfr_swap ( *x.mpfr, *y.mpfr)
  PrototypeC.l mpfr_init_set_str ( *x.mpfr, *s, base.l, rnd.l = #MPFR_RNDN)
  PrototypeC.f mpfr_get_flt ( *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.d mpfr_get_d ( *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.i mpfr_get_si ( *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.i mpfr_get_ui ( *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.d mpfr_get_d_2exp ( *exp, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_frexp ( *exp, *y.mpfr, *x.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.i mpfr_get_z_2exp ( *rop.mpz, *op.mpfr)
  PrototypeC.l mpfr_get_z ( *rop.mpz, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_get_f ( *rop.mpf, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.i mpfr_get_str ( str.s, *expptr, b.l, n.i, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC   mpfr_free_str ( *str)
  PrototypeC.l mpfr_fits_ulong_p ( *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_fits_slong_p ( *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_fits_uint_p ( *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_fits_sint_p ( *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_fits_ushort_p ( *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_fits_sshort_p ( *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_fits_uintmax_p ( *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_fits_intmax_p ( *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_add ( *rop.mpfr, *op1.mpfr, *op2.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_add_ui ( *rop.mpfr, *op1.mpfr, op2.i, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_add_si ( *rop.mpfr, *op1.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_add_d ( *rop.mpfr, *op1.mpfr, op2.d, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_add_z ( *rop.mpfr, *op1.mpfr, *op2.mpz, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_add_q ( *rop.mpfr, *op1.mpfr, *op2.mpq, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_sub ( *rop.mpfr, *op1.mpfr, *op2.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_ui_sub ( *rop.mpfr, op1.i, *op2.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_sub_ui ( *rop.mpfr, *op1.mpfr, op2.i, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_si_sub ( *rop.mpfr, *op2.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_sub_si ( *rop.mpfr, *op1.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_d_sub ( *rop.mpfr, op1.d, *op2.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_sub_d ( *rop.mpfr, *op1.mpfr, op2.d, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_z_sub ( *rop.mpfr, *op1.mpz, *op2.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_sub_z ( *rop.mpfr, *op1.mpfr, *op2.mpz, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_sub_q ( *rop.mpfr, *op1.mpfr, *op2.mpq, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_mul ( *rop.mpfr, *op1.mpfr, *op2.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_mul_ui ( *rop.mpfr, *op1.mpfr, op2.i, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_mul_si ( *rop.mpfr, *op1.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_mul_d ( *rop.mpfr, *op1.mpfr, op2.d, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_mul_z ( *rop.mpfr, *op1.mpfr, *op2.mpz, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_mul_q ( *rop.mpfr, *op1.mpfr, *op2.mpq, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_sqr ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_div ( *rop.mpfr, *op1.mpfr, *op2.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_ui_div ( *rop.mpfr, op1.i, *op2.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_div_ui ( *rop.mpfr, *op1.mpfr, op2.i, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_si_div ( *rop.mpfr, *op2.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_div_si ( *rop.mpfr, *op1.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_d_div ( *rop.mpfr, op1.d, *op2.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_div_d ( *rop.mpfr, *op1.mpfr, op2.d, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_div_z ( *rop.mpfr, *op1.mpfr, *op2.mpz, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_div_q ( *rop.mpfr, *op1.mpfr, *op2.mpq, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_sqrt ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_sqrt_ui ( *rop.mpfr, op.i, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_rec_sqrt ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_cbrt ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_root ( *rop.mpfr, *op.mpfr, k.i, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_pow ( *rop.mpfr, *op1.mpfr, *op2.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_pow_ui ( *rop.mpfr, *op1.mpfr, op2.i, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_pow_si ( *rop.mpfr, *op1.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_pow_z ( *rop.mpfr, *op1.mpfr, *op2.mpz, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_ui_pow_ui ( *rop.mpfr, op1.i, op2.i, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_ui_pow ( *rop.mpfr, op1.i, *op2.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_neg ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_abs ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_dim ( *rop.mpfr, *op1.mpfr, *op2.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_mul_2ui ( *rop.mpfr, *op1.mpfr, op2.i, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_mul_2si ( *rop.mpfr, *op1.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_div_2ui ( *rop.mpfr, *op1.mpfr, op2.i, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_div_2si ( *rop.mpfr, *op1.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_cmp ( *op1.mpfr, *op2.mpfr)
  PrototypeC.l mpfr_cmp_ui ( *op1.mpfr, op2.i)
  PrototypeC.l mpfr_cmp_si ( *op1.mpfr)
  PrototypeC.l mpfr_cmp_d ( *op1.mpfr, op2.d)
  PrototypeC.l mpfr_cmp_z ( *op1.mpfr, *op2.mpz)
  PrototypeC.l mpfr_cmp_q ( *op1.mpfr, *op2.mpq)
  PrototypeC.l mpfr_cmp_f ( *op1.mpfr, *op2.mpf)
  PrototypeC.l mpfr_cmp_ui_2exp ( *op1.mpfr, op2.i, e.i)
  PrototypeC.l mpfr_cmp_si_2exp ( *op1.mpfr, e.i)
  PrototypeC.l mpfr_cmpabs ( *op1.mpfr, *op2.mpfr)
  PrototypeC.l mpfr_nan_p ( *op.mpfr)
  PrototypeC.l mpfr_inf_p ( *op.mpfr)
  PrototypeC.l mpfr_number_p ( *op.mpfr)
  PrototypeC.l mpfr_zero_p ( *op.mpfr)
  PrototypeC.l mpfr_regular_p ( *op.mpfr)
  PrototypeC.l mpfr_greater_p ( *op1.mpfr, *op2.mpfr)
  PrototypeC.l mpfr_greaterequal_p ( *op1.mpfr, *op2.mpfr)
  PrototypeC.l mpfr_less_p ( *op1.mpfr, *op2.mpfr)
  PrototypeC.l mpfr_lessequal_p ( *op1.mpfr, *op2.mpfr)
  PrototypeC.l mpfr_equal_p ( *op1.mpfr, *op2.mpfr)
  PrototypeC.l mpfr_lessgreater_p ( *op1.mpfr, *op2.mpfr)
  PrototypeC.l mpfr_unordered_p ( *op1.mpfr, *op2.mpfr)
  PrototypeC.l mpfr_log ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_log2 ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_log10 ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_exp ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_exp2 ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_exp10 ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_cos ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_sin ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_tan ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_sin_cos ( *sop.mpfr, *cop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_sec ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_csc ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_cot ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_acos ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_asin ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_atan ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_atan2 ( *rop.mpfr, *y.mpfr, *x.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_cosh ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_sinh ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_tanh ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_sinh_cosh ( *sop.mpfr, *cop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_sech ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_csch ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_coth ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_acosh ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_asinh ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_atanh ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_fac_ui ( *rop.mpfr, op.i, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_log1p ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_expm1 ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_eint ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_li2 ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_gamma ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_lngamma ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_lgamma ( *rop.mpfr, *signp, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_digamma ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_zeta ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_zeta_ui ( *rop.mpfr, op.i, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_erf ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_erfc ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_j0 ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_j1 ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_jn ( *rop.mpfr, n.i, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_y0 ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_y1 ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_yn ( *rop.mpfr, n.i, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_fma ( *rop.mpfr, *op1.mpfr, *op2.mpfr, *op3.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_fms ( *rop.mpfr, *op1.mpfr, *op2.mpfr, *op3.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_agm ( *rop.mpfr, *op1.mpfr, *op2.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_hypot ( *rop.mpfr, *x.mpfr, *y.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_ai ( *rop.mpfr, *x.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_const_log2 ( *rop.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_const_pi ( *rop.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_const_euler ( *rop.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_const_catalan ( *rop.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC   mpfr_free_cache ()
  PrototypeC.l mpfr_sum ( *rop.mpfr, n.i, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_printf ( template.s, rnd.l=0, *x=#NUL)
  PrototypeC.l mpfr_vprintf ( template.s, rnd.l=0, *x=#NUL)
  PrototypeC.l mpfr_sprintf ( buf.s, template.s, rnd.l=0, *x=#NUL)
  PrototypeC.l mpfr_vsprintf ( buf.s, template.s,  rnd.l=0, *x=#NUL)
  PrototypeC.l mpfr_snprintf ( buf.s, n.i, template.s,  rnd.l=0, *x=#NUL)
  PrototypeC.l mpfr_vsnprintf ( buf.s, n.i, template.s,  rnd.l=0, *x=#NUL)
  PrototypeC.l mpfr_asprintf ( str.s, template.s, rnd.l=0, *x=#NUL)
  PrototypeC.l mpfr_vasprintf ( str.s, template.s, rnd.l=0, *x=#NUL)
  PrototypeC.l mpfr_rint ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_ceil ( *rop.mpfr, *op.mpfr)
  PrototypeC.l mpfr_floor ( *rop.mpfr, *op.mpfr)
  PrototypeC.l mpfr_round ( *rop.mpfr, *op.mpfr)
  PrototypeC.l mpfr_trunc ( *rop.mpfr, *op.mpfr)
  PrototypeC.l mpfr_rint_ceil ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_rint_floor ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_rint_round ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_rint_trunc ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_frac ( *rop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_modf ( *iop.mpfr, *fop.mpfr, *op.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_fmod ( *r.mpfr, *x.mpfr, *y.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_remainder ( *r.mpfr, *x.mpfr, *y.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_remquo ( *r.mpfr, *x.mpfr, *y.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_integer_p ( *op.mpfr)
  PrototypeC   mpfr_set_default_rounding_mode ( rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_get_default_rounding_mode ()
  PrototypeC.l mpfr_prec_round ( *x.mpfr, prec.i, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_can_round ( *b.mpfr, err.i, rnd1.l, rnd2.l, prec.i)
  PrototypeC.i mpfr_min_prec ( *x.mpfr)
  PrototypeC.i mpfr_print_rnd_mode ( rnd.l = #MPFR_RNDN)
  PrototypeC   mpfr_nexttoward ( *x.mpfr, *y.mpfr)
  PrototypeC   mpfr_nextabove ( *x.mpfr)
  PrototypeC   mpfr_nextbelow ( *x.mpfr)
  PrototypeC.l mpfr_min ( *rop.mpfr, *op1.mpfr, *op2.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_max ( *rop.mpfr, *op1.mpfr, *op2.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_urandomb ( *rop.mpfr, *state.gmp_randstate_t)
  PrototypeC.l mpfr_urandom ( *rop.mpfr, *state.gmp_randstate_t, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_grandom ( *rop1.mpfr, *rop2.mpfr, *state.gmp_randstate_t, rnd.l = #MPFR_RNDN)
  PrototypeC.i mpfr_get_exp ( *x.mpfr)
  PrototypeC.l mpfr_set_exp ( *x.mpfr, e.i)
  PrototypeC.l mpfr_signbit ( *op.mpfr)
  PrototypeC.l mpfr_setsign ( *rop.mpfr, *op.mpfr, s.l, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_copysign ( *rop.mpfr, *op1.mpfr, *op2.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.i mpfr_get_version ()
  PrototypeC.i mpfr_get_patches ()
  PrototypeC.l mpfr_buildopt_tls_p ()
  PrototypeC.l mpfr_buildopt_decimal_p ()
  PrototypeC.l mpfr_buildopt_gmpinternals_p ()
  PrototypeC.i mpfr_buildopt_tune_case ()
  PrototypeC.i mpfr_get_emin ()
  PrototypeC.i mpfr_get_emax ()
  PrototypeC.l mpfr_set_emin ( exp.i)
  PrototypeC.l mpfr_set_emax ( exp.i)
  PrototypeC.i mpfr_get_emin_min ()
  PrototypeC.i mpfr_get_emin_max ()
  PrototypeC.i mpfr_get_emax_min ()
  PrototypeC.i mpfr_get_emax_max ()
  PrototypeC.l mpfr_check_range ( *x.mpfr, t.l, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_subnormalize ( *x.mpfr, t.l, rnd.l = #MPFR_RNDN)
  PrototypeC   mpfr_clear_underflow ()
  PrototypeC   mpfr_clear_overflow ()
  PrototypeC   mpfr_clear_divby0 ()
  PrototypeC   mpfr_clear_nanflag ()
  PrototypeC   mpfr_clear_inexflag ()
  PrototypeC   mpfr_clear_erangeflag ()
  PrototypeC   mpfr_set_underflow ()
  PrototypeC   mpfr_set_overflow ()
  PrototypeC   mpfr_set_divby0 ()
  PrototypeC   mpfr_set_nanflag ()
  PrototypeC   mpfr_set_inexflag ()
  PrototypeC   mpfr_set_erangeflag ()
  PrototypeC   mpfr_clear_flags ()
  PrototypeC.l mpfr_underflow_p ()
  PrototypeC.l mpfr_overflow_p ()
  PrototypeC.l mpfr_divby0_p ()
  PrototypeC.l mpfr_nanflag_p ()
  PrototypeC.l mpfr_inexflag_p ()
  PrototypeC.l mpfr_erangeflag_p ()
  PrototypeC   mpfr_set_prec_raw ( *x.mpfr, prec.i)
  PrototypeC.l mpfr_eq ( *op1.mpfr, *op2.mpfr, op3.i)
  PrototypeC   mpfr_reldiff ( *rop.mpfr, *op1.mpfr, *op2.mpfr, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_mul_2exp ( *rop.mpfr, *op1.mpfr, op2.i, rnd.l = #MPFR_RNDN)
  PrototypeC.l mpfr_div_2exp ( *rop.mpfr, *op1.mpfr, op2.i, rnd.l = #MPFR_RNDN)
  PrototypeC.i mpfr_custom_get_size ( prec.i)
  PrototypeC   mpfr_custom_init ( *significand, prec.i)
  PrototypeC   mpfr_custom_init_set ( *x.mpfr, kind.l, exp.i, prec.i, *significand)
  PrototypeC.l mpfr_custom_get_kind ( *x.mpfr)
  PrototypeC.i mpfr_custom_get_significand ( *x.mpfr)
  PrototypeC.i mpfr_custom_get_exp ( *x.mpfr)
  PrototypeC   mpfr_custom_move ( *x.mpfr, *new_position)

  Global mpfr_init2.i : mpfr_init2.mpfr_init2 = GetFunction(MPFRLibrary, "mpfr_init2" )
  Global mpfr_clear.i : mpfr_clear.mpfr_clear = GetFunction(MPFRLibrary, "mpfr_clear" )
  Global mpfr_init.i : mpfr_init.mpfr_init = GetFunction(MPFRLibrary, "mpfr_init" )
  Global mpfr_set_default_prec.i : mpfr_set_default_prec.mpfr_set_default_prec = GetFunction(MPFRLibrary, "mpfr_set_default_prec" )
  Global mpfr_get_default_prec.i : mpfr_get_default_prec.mpfr_get_default_prec = GetFunction(MPFRLibrary, "mpfr_get_default_prec" )
  Global mpfr_set_prec.i : mpfr_set_prec.mpfr_set_prec = GetFunction(MPFRLibrary, "mpfr_set_prec" )
  Global mpfr_get_prec.i : mpfr_get_prec.mpfr_get_prec = GetFunction(MPFRLibrary, "mpfr_get_prec" )
  Global mpfr_set.i : mpfr_set.mpfr_set = GetFunction(MPFRLibrary, "mpfr_set" )
  Global mpfr_set_ui.i : mpfr_set_ui.mpfr_set_ui = GetFunction(MPFRLibrary, "mpfr_set_ui" )
  Global mpfr_set_si.i : mpfr_set_si.mpfr_set_si = GetFunction(MPFRLibrary, "mpfr_set_si" )
  Global mpfr_set_flt.i : mpfr_set_flt.mpfr_set_flt = GetFunction(MPFRLibrary, "mpfr_set_flt" )
  Global mpfr_set_d.i : mpfr_set_d.mpfr_set_d = GetFunction(MPFRLibrary, "mpfr_set_d" )
  Global mpfr_set_z.i : mpfr_set_z.mpfr_set_z = GetFunction(MPFRLibrary, "mpfr_set_z" )
  Global mpfr_set_q.i : mpfr_set_q.mpfr_set_q = GetFunction(MPFRLibrary, "mpfr_set_q" )
  Global mpfr_set_f.i : mpfr_set_f.mpfr_set_f = GetFunction(MPFRLibrary, "mpfr_set_f" )
  Global mpfr_set_ui_2exp.i : mpfr_set_ui_2exp.mpfr_set_ui_2exp = GetFunction(MPFRLibrary, "mpfr_set_ui_2exp" )
  Global mpfr_set_si_2exp.i : mpfr_set_si_2exp.mpfr_set_si_2exp = GetFunction(MPFRLibrary, "mpfr_set_si_2exp" )
  Global mpfr_set_z_2exp.i : mpfr_set_z_2exp.mpfr_set_z_2exp = GetFunction(MPFRLibrary, "mpfr_set_z_2exp" )
  Global mpfr_set_str.i : mpfr_set_str.mpfr_set_str = GetFunction(MPFRLibrary, "mpfr_set_str" )
  Global mpfr_strtofr.i : mpfr_strtofr.mpfr_strtofr = GetFunction(MPFRLibrary, "mpfr_strtofr" )
  Global mpfr_set_nan.i : mpfr_set_nan.mpfr_set_nan = GetFunction(MPFRLibrary, "mpfr_set_nan" )
  Global mpfr_set_inf.i : mpfr_set_inf.mpfr_set_inf = GetFunction(MPFRLibrary, "mpfr_set_inf" )
  Global mpfr_set_zero.i : mpfr_set_zero.mpfr_set_zero = GetFunction(MPFRLibrary, "mpfr_set_zero" )
  Global mpfr_swap.i : mpfr_swap.mpfr_swap = GetFunction(MPFRLibrary, "mpfr_swap" )
  Global mpfr_init_set_str.i : mpfr_init_set_str.mpfr_init_set_str = GetFunction(MPFRLibrary, "mpfr_init_set_str" )
  Global mpfr_get_flt.i : mpfr_get_flt.mpfr_get_flt = GetFunction(MPFRLibrary, "mpfr_get_flt" )
  Global mpfr_get_d.i : mpfr_get_d.mpfr_get_d = GetFunction(MPFRLibrary, "mpfr_get_d" )
  Global mpfr_get_si.i : mpfr_get_si.mpfr_get_si = GetFunction(MPFRLibrary, "mpfr_get_si" )
  Global mpfr_get_ui.i : mpfr_get_ui.mpfr_get_ui = GetFunction(MPFRLibrary, "mpfr_get_ui" )
  Global mpfr_get_d_2exp.i : mpfr_get_d_2exp.mpfr_get_d_2exp = GetFunction(MPFRLibrary, "mpfr_get_d_2exp" )
  Global mpfr_frexp.i : mpfr_frexp.mpfr_frexp = GetFunction(MPFRLibrary, "mpfr_frexp" )
  Global mpfr_get_z_2exp.i : mpfr_get_z_2exp.mpfr_get_z_2exp = GetFunction(MPFRLibrary, "mpfr_get_z_2exp" )
  Global mpfr_get_z.i : mpfr_get_z.mpfr_get_z = GetFunction(MPFRLibrary, "mpfr_get_z" )
  Global mpfr_get_f.i : mpfr_get_f.mpfr_get_f = GetFunction(MPFRLibrary, "mpfr_get_f" )
  Global mpfr_get_str.i : mpfr_get_str.mpfr_get_str = GetFunction(MPFRLibrary, "mpfr_get_str" )
  Global mpfr_free_str.i : mpfr_free_str.mpfr_free_str = GetFunction(MPFRLibrary, "mpfr_free_str" )
  Global mpfr_fits_ulong_p.i : mpfr_fits_ulong_p.mpfr_fits_ulong_p = GetFunction(MPFRLibrary, "mpfr_fits_ulong_p" )
  Global mpfr_fits_slong_p.i : mpfr_fits_slong_p.mpfr_fits_slong_p = GetFunction(MPFRLibrary, "mpfr_fits_slong_p" )
  Global mpfr_fits_uint_p.i : mpfr_fits_uint_p.mpfr_fits_uint_p = GetFunction(MPFRLibrary, "mpfr_fits_uint_p" )
  Global mpfr_fits_sint_p.i : mpfr_fits_sint_p.mpfr_fits_sint_p = GetFunction(MPFRLibrary, "mpfr_fits_sint_p" )
  Global mpfr_fits_ushort_p.i : mpfr_fits_ushort_p.mpfr_fits_ushort_p = GetFunction(MPFRLibrary, "mpfr_fits_ushort_p" )
  Global mpfr_fits_sshort_p.i : mpfr_fits_sshort_p.mpfr_fits_sshort_p = GetFunction(MPFRLibrary, "mpfr_fits_sshort_p" )
  Global mpfr_fits_uintmax_p.i : mpfr_fits_uintmax_p.mpfr_fits_uintmax_p = GetFunction(MPFRLibrary, "mpfr_fits_uintmax_p" )
  Global mpfr_fits_intmax_p.i : mpfr_fits_intmax_p.mpfr_fits_intmax_p = GetFunction(MPFRLibrary, "mpfr_fits_intmax_p" )
  Global mpfr_add.i : mpfr_add.mpfr_add = GetFunction(MPFRLibrary, "mpfr_add" )
  Global mpfr_add_ui.i : mpfr_add_ui.mpfr_add_ui = GetFunction(MPFRLibrary, "mpfr_add_ui" )
  Global mpfr_add_si.i : mpfr_add_si.mpfr_add_si = GetFunction(MPFRLibrary, "mpfr_add_si" )
  Global mpfr_add_d.i : mpfr_add_d.mpfr_add_d = GetFunction(MPFRLibrary, "mpfr_add_d" )
  Global mpfr_add_z.i : mpfr_add_z.mpfr_add_z = GetFunction(MPFRLibrary, "mpfr_add_z" )
  Global mpfr_add_q.i : mpfr_add_q.mpfr_add_q = GetFunction(MPFRLibrary, "mpfr_add_q" )
  Global mpfr_sub.i : mpfr_sub.mpfr_sub = GetFunction(MPFRLibrary, "mpfr_sub" )
  Global mpfr_ui_sub.i : mpfr_ui_sub.mpfr_ui_sub = GetFunction(MPFRLibrary, "mpfr_ui_sub" )
  Global mpfr_sub_ui.i : mpfr_sub_ui.mpfr_sub_ui = GetFunction(MPFRLibrary, "mpfr_sub_ui" )
  Global mpfr_si_sub.i : mpfr_si_sub.mpfr_si_sub = GetFunction(MPFRLibrary, "mpfr_si_sub" )
  Global mpfr_sub_si.i : mpfr_sub_si.mpfr_sub_si = GetFunction(MPFRLibrary, "mpfr_sub_si" )
  Global mpfr_d_sub.i : mpfr_d_sub.mpfr_d_sub = GetFunction(MPFRLibrary, "mpfr_d_sub" )
  Global mpfr_sub_d.i : mpfr_sub_d.mpfr_sub_d = GetFunction(MPFRLibrary, "mpfr_sub_d" )
  Global mpfr_z_sub.i : mpfr_z_sub.mpfr_z_sub = GetFunction(MPFRLibrary, "mpfr_z_sub" )
  Global mpfr_sub_z.i : mpfr_sub_z.mpfr_sub_z = GetFunction(MPFRLibrary, "mpfr_sub_z" )
  Global mpfr_sub_q.i : mpfr_sub_q.mpfr_sub_q = GetFunction(MPFRLibrary, "mpfr_sub_q" )
  Global mpfr_mul.i : mpfr_mul.mpfr_mul = GetFunction(MPFRLibrary, "mpfr_mul" )
  Global mpfr_mul_ui.i : mpfr_mul_ui.mpfr_mul_ui = GetFunction(MPFRLibrary, "mpfr_mul_ui" )
  Global mpfr_mul_si.i : mpfr_mul_si.mpfr_mul_si = GetFunction(MPFRLibrary, "mpfr_mul_si" )
  Global mpfr_mul_d.i : mpfr_mul_d.mpfr_mul_d = GetFunction(MPFRLibrary, "mpfr_mul_d" )
  Global mpfr_mul_z.i : mpfr_mul_z.mpfr_mul_z = GetFunction(MPFRLibrary, "mpfr_mul_z" )
  Global mpfr_mul_q.i : mpfr_mul_q.mpfr_mul_q = GetFunction(MPFRLibrary, "mpfr_mul_q" )
  Global mpfr_sqr.i : mpfr_sqr.mpfr_sqr = GetFunction(MPFRLibrary, "mpfr_sqr" )
  Global mpfr_div.i : mpfr_div.mpfr_div = GetFunction(MPFRLibrary, "mpfr_div" )
  Global mpfr_ui_div.i : mpfr_ui_div.mpfr_ui_div = GetFunction(MPFRLibrary, "mpfr_ui_div" )
  Global mpfr_div_ui.i : mpfr_div_ui.mpfr_div_ui = GetFunction(MPFRLibrary, "mpfr_div_ui" )
  Global mpfr_si_div.i : mpfr_si_div.mpfr_si_div = GetFunction(MPFRLibrary, "mpfr_si_div" )
  Global mpfr_div_si.i : mpfr_div_si.mpfr_div_si = GetFunction(MPFRLibrary, "mpfr_div_si" )
  Global mpfr_d_div.i : mpfr_d_div.mpfr_d_div = GetFunction(MPFRLibrary, "mpfr_d_div" )
  Global mpfr_div_d.i : mpfr_div_d.mpfr_div_d = GetFunction(MPFRLibrary, "mpfr_div_d" )
  Global mpfr_div_z.i : mpfr_div_z.mpfr_div_z = GetFunction(MPFRLibrary, "mpfr_div_z" )
  Global mpfr_div_q.i : mpfr_div_q.mpfr_div_q = GetFunction(MPFRLibrary, "mpfr_div_q" )
  Global mpfr_sqrt.i : mpfr_sqrt.mpfr_sqrt = GetFunction(MPFRLibrary, "mpfr_sqrt" )
  Global mpfr_sqrt_ui.i : mpfr_sqrt_ui.mpfr_sqrt_ui = GetFunction(MPFRLibrary, "mpfr_sqrt_ui" )
  Global mpfr_rec_sqrt.i : mpfr_rec_sqrt.mpfr_rec_sqrt = GetFunction(MPFRLibrary, "mpfr_rec_sqrt" )
  Global mpfr_cbrt.i : mpfr_cbrt.mpfr_cbrt = GetFunction(MPFRLibrary, "mpfr_cbrt" )
  Global mpfr_root.i : mpfr_root.mpfr_root = GetFunction(MPFRLibrary, "mpfr_root" )
  Global mpfr_pow.i : mpfr_pow.mpfr_pow = GetFunction(MPFRLibrary, "mpfr_pow" )
  Global mpfr_pow_ui.i : mpfr_pow_ui.mpfr_pow_ui = GetFunction(MPFRLibrary, "mpfr_pow_ui" )
  Global mpfr_pow_si.i : mpfr_pow_si.mpfr_pow_si = GetFunction(MPFRLibrary, "mpfr_pow_si" )
  Global mpfr_pow_z.i : mpfr_pow_z.mpfr_pow_z = GetFunction(MPFRLibrary, "mpfr_pow_z" )
  Global mpfr_ui_pow_ui.i : mpfr_ui_pow_ui.mpfr_ui_pow_ui = GetFunction(MPFRLibrary, "mpfr_ui_pow_ui" )
  Global mpfr_ui_pow.i : mpfr_ui_pow.mpfr_ui_pow = GetFunction(MPFRLibrary, "mpfr_ui_pow" )
  Global mpfr_neg.i : mpfr_neg.mpfr_neg = GetFunction(MPFRLibrary, "mpfr_neg" )
  Global mpfr_abs.i : mpfr_abs.mpfr_abs = GetFunction(MPFRLibrary, "mpfr_abs" )
  Global mpfr_dim.i : mpfr_dim.mpfr_dim = GetFunction(MPFRLibrary, "mpfr_dim" )
  Global mpfr_mul_2ui.i : mpfr_mul_2ui.mpfr_mul_2ui = GetFunction(MPFRLibrary, "mpfr_mul_2ui" )
  Global mpfr_mul_2si.i : mpfr_mul_2si.mpfr_mul_2si = GetFunction(MPFRLibrary, "mpfr_mul_2si" )
  Global mpfr_div_2ui.i : mpfr_div_2ui.mpfr_div_2ui = GetFunction(MPFRLibrary, "mpfr_div_2ui" )
  Global mpfr_div_2si.i : mpfr_div_2si.mpfr_div_2si = GetFunction(MPFRLibrary, "mpfr_div_2si" )
  Global mpfr_cmp.i : mpfr_cmp.mpfr_cmp = GetFunction(MPFRLibrary, "mpfr_cmp" )
  Global mpfr_cmp_ui.i : mpfr_cmp_ui.mpfr_cmp_ui = GetFunction(MPFRLibrary, "mpfr_cmp_ui" )
  Global mpfr_cmp_si.i : mpfr_cmp_si.mpfr_cmp_si = GetFunction(MPFRLibrary, "mpfr_cmp_si" )
  Global mpfr_cmp_d.i : mpfr_cmp_d.mpfr_cmp_d = GetFunction(MPFRLibrary, "mpfr_cmp_d" )
  Global mpfr_cmp_z.i : mpfr_cmp_z.mpfr_cmp_z = GetFunction(MPFRLibrary, "mpfr_cmp_z" )
  Global mpfr_cmp_q.i : mpfr_cmp_q.mpfr_cmp_q = GetFunction(MPFRLibrary, "mpfr_cmp_q" )
  Global mpfr_cmp_f.i : mpfr_cmp_f.mpfr_cmp_f = GetFunction(MPFRLibrary, "mpfr_cmp_f" )
  Global mpfr_cmp_ui_2exp.i : mpfr_cmp_ui_2exp.mpfr_cmp_ui_2exp = GetFunction(MPFRLibrary, "mpfr_cmp_ui_2exp" )
  Global mpfr_cmp_si_2exp.i : mpfr_cmp_si_2exp.mpfr_cmp_si_2exp = GetFunction(MPFRLibrary, "mpfr_cmp_si_2exp" )
  Global mpfr_cmpabs.i : mpfr_cmpabs.mpfr_cmpabs = GetFunction(MPFRLibrary, "mpfr_cmpabs" )
  Global mpfr_nan_p.i : mpfr_nan_p.mpfr_nan_p = GetFunction(MPFRLibrary, "mpfr_nan_p" )
  Global mpfr_inf_p.i : mpfr_inf_p.mpfr_inf_p = GetFunction(MPFRLibrary, "mpfr_inf_p" )
  Global mpfr_number_p.i : mpfr_number_p.mpfr_number_p = GetFunction(MPFRLibrary, "mpfr_number_p" )
  Global mpfr_zero_p.i : mpfr_zero_p.mpfr_zero_p = GetFunction(MPFRLibrary, "mpfr_zero_p" )
  Global mpfr_regular_p.i : mpfr_regular_p.mpfr_regular_p = GetFunction(MPFRLibrary, "mpfr_regular_p" )
  Global mpfr_greater_p.i : mpfr_greater_p.mpfr_greater_p = GetFunction(MPFRLibrary, "mpfr_greater_p" )
  Global mpfr_greaterequal_p.i : mpfr_greaterequal_p.mpfr_greaterequal_p = GetFunction(MPFRLibrary, "mpfr_greaterequal_p" )
  Global mpfr_less_p.i : mpfr_less_p.mpfr_less_p = GetFunction(MPFRLibrary, "mpfr_less_p" )
  Global mpfr_lessequal_p.i : mpfr_lessequal_p.mpfr_lessequal_p = GetFunction(MPFRLibrary, "mpfr_lessequal_p" )
  Global mpfr_equal_p.i : mpfr_equal_p.mpfr_equal_p = GetFunction(MPFRLibrary, "mpfr_equal_p" )
  Global mpfr_lessgreater_p.i : mpfr_lessgreater_p.mpfr_lessgreater_p = GetFunction(MPFRLibrary, "mpfr_lessgreater_p" )
  Global mpfr_unordered_p.i : mpfr_unordered_p.mpfr_unordered_p = GetFunction(MPFRLibrary, "mpfr_unordered_p" )
  Global mpfr_log.i : mpfr_log.mpfr_log = GetFunction(MPFRLibrary, "mpfr_log" )
  Global mpfr_log2.i : mpfr_log2.mpfr_log2 = GetFunction(MPFRLibrary, "mpfr_log2" )
  Global mpfr_log10.i : mpfr_log10.mpfr_log10 = GetFunction(MPFRLibrary, "mpfr_log10" )
  Global mpfr_exp.i : mpfr_exp.mpfr_exp = GetFunction(MPFRLibrary, "mpfr_exp" )
  Global mpfr_exp2.i : mpfr_exp2.mpfr_exp2 = GetFunction(MPFRLibrary, "mpfr_exp2" )
  Global mpfr_exp10.i : mpfr_exp10.mpfr_exp10 = GetFunction(MPFRLibrary, "mpfr_exp10" )
  Global mpfr_cos.i : mpfr_cos.mpfr_cos = GetFunction(MPFRLibrary, "mpfr_cos" )
  Global mpfr_sin.i : mpfr_sin.mpfr_sin = GetFunction(MPFRLibrary, "mpfr_sin" )
  Global mpfr_tan.i : mpfr_tan.mpfr_tan = GetFunction(MPFRLibrary, "mpfr_tan" )
  Global mpfr_sin_cos.i : mpfr_sin_cos.mpfr_sin_cos = GetFunction(MPFRLibrary, "mpfr_sin_cos" )
  Global mpfr_sec.i : mpfr_sec.mpfr_sec = GetFunction(MPFRLibrary, "mpfr_sec" )
  Global mpfr_csc.i : mpfr_csc.mpfr_csc = GetFunction(MPFRLibrary, "mpfr_csc" )
  Global mpfr_cot.i : mpfr_cot.mpfr_cot = GetFunction(MPFRLibrary, "mpfr_cot" )
  Global mpfr_acos.i : mpfr_acos.mpfr_acos = GetFunction(MPFRLibrary, "mpfr_acos" )
  Global mpfr_asin.i : mpfr_asin.mpfr_asin = GetFunction(MPFRLibrary, "mpfr_asin" )
  Global mpfr_atan.i : mpfr_atan.mpfr_atan = GetFunction(MPFRLibrary, "mpfr_atan" )
  Global mpfr_atan2.i : mpfr_atan2.mpfr_atan2 = GetFunction(MPFRLibrary, "mpfr_atan2" )
  Global mpfr_cosh.i : mpfr_cosh.mpfr_cosh = GetFunction(MPFRLibrary, "mpfr_cosh" )
  Global mpfr_sinh.i : mpfr_sinh.mpfr_sinh = GetFunction(MPFRLibrary, "mpfr_sinh" )
  Global mpfr_tanh.i : mpfr_tanh.mpfr_tanh = GetFunction(MPFRLibrary, "mpfr_tanh" )
  Global mpfr_sinh_cosh.i : mpfr_sinh_cosh.mpfr_sinh_cosh = GetFunction(MPFRLibrary, "mpfr_sinh_cosh" )
  Global mpfr_sech.i : mpfr_sech.mpfr_sech = GetFunction(MPFRLibrary, "mpfr_sech" )
  Global mpfr_csch.i : mpfr_csch.mpfr_csch = GetFunction(MPFRLibrary, "mpfr_csch" )
  Global mpfr_coth.i : mpfr_coth.mpfr_coth = GetFunction(MPFRLibrary, "mpfr_coth" )
  Global mpfr_acosh.i : mpfr_acosh.mpfr_acosh = GetFunction(MPFRLibrary, "mpfr_acosh" )
  Global mpfr_asinh.i : mpfr_asinh.mpfr_asinh = GetFunction(MPFRLibrary, "mpfr_asinh" )
  Global mpfr_atanh.i : mpfr_atanh.mpfr_atanh = GetFunction(MPFRLibrary, "mpfr_atanh" )
  Global mpfr_fac_ui.i : mpfr_fac_ui.mpfr_fac_ui = GetFunction(MPFRLibrary, "mpfr_fac_ui" )
  Global mpfr_log1p.i : mpfr_log1p.mpfr_log1p = GetFunction(MPFRLibrary, "mpfr_log1p" )
  Global mpfr_expm1.i : mpfr_expm1.mpfr_expm1 = GetFunction(MPFRLibrary, "mpfr_expm1" )
  Global mpfr_eint.i : mpfr_eint.mpfr_eint = GetFunction(MPFRLibrary, "mpfr_eint" )
  Global mpfr_li2.i : mpfr_li2.mpfr_li2 = GetFunction(MPFRLibrary, "mpfr_li2" )
  Global mpfr_gamma.i : mpfr_gamma.mpfr_gamma = GetFunction(MPFRLibrary, "mpfr_gamma" )
  Global mpfr_lngamma.i : mpfr_lngamma.mpfr_lngamma = GetFunction(MPFRLibrary, "mpfr_lngamma" )
  Global mpfr_lgamma.i : mpfr_lgamma.mpfr_lgamma = GetFunction(MPFRLibrary, "mpfr_lgamma" )
  Global mpfr_digamma.i : mpfr_digamma.mpfr_digamma = GetFunction(MPFRLibrary, "mpfr_digamma" )
  Global mpfr_zeta.i : mpfr_zeta.mpfr_zeta = GetFunction(MPFRLibrary, "mpfr_zeta" )
  Global mpfr_zeta_ui.i : mpfr_zeta_ui.mpfr_zeta_ui = GetFunction(MPFRLibrary, "mpfr_zeta_ui" )
  Global mpfr_erf.i : mpfr_erf.mpfr_erf = GetFunction(MPFRLibrary, "mpfr_erf" )
  Global mpfr_erfc.i : mpfr_erfc.mpfr_erfc = GetFunction(MPFRLibrary, "mpfr_erfc" )
  Global mpfr_j0.i : mpfr_j0.mpfr_j0 = GetFunction(MPFRLibrary, "mpfr_j0" )
  Global mpfr_j1.i : mpfr_j1.mpfr_j1 = GetFunction(MPFRLibrary, "mpfr_j1" )
  Global mpfr_jn.i : mpfr_jn.mpfr_jn = GetFunction(MPFRLibrary, "mpfr_jn" )
  Global mpfr_y0.i : mpfr_y0.mpfr_y0 = GetFunction(MPFRLibrary, "mpfr_y0" )
  Global mpfr_y1.i : mpfr_y1.mpfr_y1 = GetFunction(MPFRLibrary, "mpfr_y1" )
  Global mpfr_yn.i : mpfr_yn.mpfr_yn = GetFunction(MPFRLibrary, "mpfr_yn" )
  Global mpfr_fma.i : mpfr_fma.mpfr_fma = GetFunction(MPFRLibrary, "mpfr_fma" )
  Global mpfr_fms.i : mpfr_fms.mpfr_fms = GetFunction(MPFRLibrary, "mpfr_fms" )
  Global mpfr_agm.i : mpfr_agm.mpfr_agm = GetFunction(MPFRLibrary, "mpfr_agm" )
  Global mpfr_hypot.i : mpfr_hypot.mpfr_hypot = GetFunction(MPFRLibrary, "mpfr_hypot" )
  Global mpfr_ai.i : mpfr_ai.mpfr_ai = GetFunction(MPFRLibrary, "mpfr_ai" )
  Global mpfr_const_log2.i : mpfr_const_log2.mpfr_const_log2 = GetFunction(MPFRLibrary, "mpfr_const_log2" )
  Global mpfr_const_pi.i : mpfr_const_pi.mpfr_const_pi = GetFunction(MPFRLibrary, "mpfr_const_pi" )
  Global mpfr_const_euler.i : mpfr_const_euler.mpfr_const_euler = GetFunction(MPFRLibrary, "mpfr_const_euler" )
  Global mpfr_const_catalan.i : mpfr_const_catalan.mpfr_const_catalan = GetFunction(MPFRLibrary, "mpfr_const_catalan" )
  Global mpfr_free_cache.i : mpfr_free_cache.mpfr_free_cache = GetFunction(MPFRLibrary, "mpfr_free_cache" )
  Global mpfr_sum.i : mpfr_sum.mpfr_sum = GetFunction(MPFRLibrary, "mpfr_sum" )
  Global mpfr_printf.i : mpfr_printf.mpfr_printf = GetFunction(MPFRLibrary, "mpfr_printf" )
  Global mpfr_vprintf.i : mpfr_vprintf.mpfr_vprintf = GetFunction(MPFRLibrary, "__gmpfr_vprintf" )
  Global mpfr_sprintf.i : mpfr_sprintf.mpfr_sprintf = GetFunction(MPFRLibrary, "mpfr_sprintf" )
  Global mpfr_vsprintf.i : mpfr_vsprintf.mpfr_vsprintf = GetFunction(MPFRLibrary, "__gmpfr_vsprintf" )
  Global mpfr_snprintf.i : mpfr_snprintf.mpfr_snprintf = GetFunction(MPFRLibrary, "mpfr_snprintf" )
  Global mpfr_vsnprintf.i : mpfr_vsnprintf.mpfr_vsnprintf = GetFunction(MPFRLibrary, "__gmpfr_vsnprintf" )
  Global mpfr_asprintf.i : mpfr_asprintf.mpfr_asprintf = GetFunction(MPFRLibrary, "mpfr_asprintf" )
  Global mpfr_vasprintf.i : mpfr_vasprintf.mpfr_vasprintf = GetFunction(MPFRLibrary, "__gmpfr_vasprintf" )
  Global mpfr_rint.i : mpfr_rint.mpfr_rint = GetFunction(MPFRLibrary, "mpfr_rint" )
  Global mpfr_ceil.i : mpfr_ceil.mpfr_ceil = GetFunction(MPFRLibrary, "mpfr_ceil" )
  Global mpfr_floor.i : mpfr_floor.mpfr_floor = GetFunction(MPFRLibrary, "mpfr_floor" )
  Global mpfr_round.i : mpfr_round.mpfr_round = GetFunction(MPFRLibrary, "mpfr_round" )
  Global mpfr_trunc.i : mpfr_trunc.mpfr_trunc = GetFunction(MPFRLibrary, "mpfr_trunc" )
  Global mpfr_rint_ceil.i : mpfr_rint_ceil.mpfr_rint_ceil = GetFunction(MPFRLibrary, "mpfr_rint_ceil" )
  Global mpfr_rint_floor.i : mpfr_rint_floor.mpfr_rint_floor = GetFunction(MPFRLibrary, "mpfr_rint_floor" )
  Global mpfr_rint_round.i : mpfr_rint_round.mpfr_rint_round = GetFunction(MPFRLibrary, "mpfr_rint_round" )
  Global mpfr_rint_trunc.i : mpfr_rint_trunc.mpfr_rint_trunc = GetFunction(MPFRLibrary, "mpfr_rint_trunc" )
  Global mpfr_frac.i : mpfr_frac.mpfr_frac = GetFunction(MPFRLibrary, "mpfr_frac" )
  Global mpfr_modf.i : mpfr_modf.mpfr_modf = GetFunction(MPFRLibrary, "mpfr_modf" )
  Global mpfr_fmod.i : mpfr_fmod.mpfr_fmod = GetFunction(MPFRLibrary, "mpfr_fmod" )
  Global mpfr_remainder.i : mpfr_remainder.mpfr_remainder = GetFunction(MPFRLibrary, "mpfr_remainder" )
  Global mpfr_remquo.i : mpfr_remquo.mpfr_remquo = GetFunction(MPFRLibrary, "mpfr_remquo" )
  Global mpfr_integer_p.i : mpfr_integer_p.mpfr_integer_p = GetFunction(MPFRLibrary, "mpfr_integer_p" )
  Global mpfr_set_default_rounding_mode.i : mpfr_set_default_rounding_mode.mpfr_set_default_rounding_mode = GetFunction(MPFRLibrary, "mpfr_set_default_rounding_mode" )
  Global mpfr_get_default_rounding_mode.i : mpfr_get_default_rounding_mode.mpfr_get_default_rounding_mode = GetFunction(MPFRLibrary, "mpfr_get_default_rounding_mode" )
  Global mpfr_prec_round.i : mpfr_prec_round.mpfr_prec_round = GetFunction(MPFRLibrary, "mpfr_prec_round" )
  Global mpfr_can_round.i : mpfr_can_round.mpfr_can_round = GetFunction(MPFRLibrary, "mpfr_can_round" )
  Global mpfr_min_prec.i : mpfr_min_prec.mpfr_min_prec = GetFunction(MPFRLibrary, "mpfr_min_prec" )
  Global mpfr_print_rnd_mode.i : mpfr_print_rnd_mode.mpfr_print_rnd_mode = GetFunction(MPFRLibrary, "mpfr_print_rnd_mode" )
  Global mpfr_nexttoward.i : mpfr_nexttoward.mpfr_nexttoward = GetFunction(MPFRLibrary, "mpfr_nexttoward" )
  Global mpfr_nextabove.i : mpfr_nextabove.mpfr_nextabove = GetFunction(MPFRLibrary, "mpfr_nextabove" )
  Global mpfr_nextbelow.i : mpfr_nextbelow.mpfr_nextbelow = GetFunction(MPFRLibrary, "mpfr_nextbelow" )
  Global mpfr_min.i : mpfr_min.mpfr_min = GetFunction(MPFRLibrary, "mpfr_min" )
  Global mpfr_max.i : mpfr_max.mpfr_max = GetFunction(MPFRLibrary, "mpfr_max" )
  Global mpfr_urandomb.i : mpfr_urandomb.mpfr_urandomb = GetFunction(MPFRLibrary, "mpfr_urandomb" )
  Global mpfr_urandom.i : mpfr_urandom.mpfr_urandom = GetFunction(MPFRLibrary, "mpfr_urandom" )
  Global mpfr_grandom.i : mpfr_grandom.mpfr_grandom = GetFunction(MPFRLibrary, "mpfr_grandom" )
  Global mpfr_get_exp.i : mpfr_get_exp.mpfr_get_exp = GetFunction(MPFRLibrary, "mpfr_get_exp" )
  Global mpfr_set_exp.i : mpfr_set_exp.mpfr_set_exp = GetFunction(MPFRLibrary, "mpfr_set_exp" )
  Global mpfr_signbit.i : mpfr_signbit.mpfr_signbit = GetFunction(MPFRLibrary, "mpfr_signbit" )
  Global mpfr_setsign.i : mpfr_setsign.mpfr_setsign = GetFunction(MPFRLibrary, "mpfr_setsign" )
  Global mpfr_copysign.i : mpfr_copysign.mpfr_copysign = GetFunction(MPFRLibrary, "mpfr_copysign" )
  Global mpfr_get_version.i : mpfr_get_version.mpfr_get_version = GetFunction(MPFRLibrary, "mpfr_get_version" )
  Global mpfr_get_patches.i : mpfr_get_patches.mpfr_get_patches = GetFunction(MPFRLibrary, "mpfr_get_patches" )
  Global mpfr_buildopt_tls_p.i : mpfr_buildopt_tls_p.mpfr_buildopt_tls_p = GetFunction(MPFRLibrary, "mpfr_buildopt_tls_p" )
  Global mpfr_buildopt_decimal_p.i : mpfr_buildopt_decimal_p.mpfr_buildopt_decimal_p = GetFunction(MPFRLibrary, "mpfr_buildopt_decimal_p" )
  Global mpfr_buildopt_gmpinternals_p.i : mpfr_buildopt_gmpinternals_p.mpfr_buildopt_gmpinternals_p = GetFunction(MPFRLibrary, "mpfr_buildopt_gmpinternals_p" )
  Global mpfr_buildopt_tune_case.i : mpfr_buildopt_tune_case.mpfr_buildopt_tune_case = GetFunction(MPFRLibrary, "mpfr_buildopt_tune_case" )
  Global mpfr_get_emin.i : mpfr_get_emin.mpfr_get_emin = GetFunction(MPFRLibrary, "mpfr_get_emin" )
  Global mpfr_get_emax.i : mpfr_get_emax.mpfr_get_emax = GetFunction(MPFRLibrary, "mpfr_get_emax" )
  Global mpfr_set_emin.i : mpfr_set_emin.mpfr_set_emin = GetFunction(MPFRLibrary, "mpfr_set_emin" )
  Global mpfr_set_emax.i : mpfr_set_emax.mpfr_set_emax = GetFunction(MPFRLibrary, "mpfr_set_emax" )
  Global mpfr_get_emin_min.i : mpfr_get_emin_min.mpfr_get_emin_min = GetFunction(MPFRLibrary, "mpfr_get_emin_min" )
  Global mpfr_get_emin_max.i : mpfr_get_emin_max.mpfr_get_emin_max = GetFunction(MPFRLibrary, "mpfr_get_emin_max" )
  Global mpfr_get_emax_min.i : mpfr_get_emax_min.mpfr_get_emax_min = GetFunction(MPFRLibrary, "mpfr_get_emax_min" )
  Global mpfr_get_emax_max.i : mpfr_get_emax_max.mpfr_get_emax_max = GetFunction(MPFRLibrary, "mpfr_get_emax_max" )
  Global mpfr_check_range.i : mpfr_check_range.mpfr_check_range = GetFunction(MPFRLibrary, "mpfr_check_range" )
  Global mpfr_subnormalize.i : mpfr_subnormalize.mpfr_subnormalize = GetFunction(MPFRLibrary, "mpfr_subnormalize" )
  Global mpfr_clear_underflow.i : mpfr_clear_underflow.mpfr_clear_underflow = GetFunction(MPFRLibrary, "mpfr_clear_underflow" )
  Global mpfr_clear_overflow.i : mpfr_clear_overflow.mpfr_clear_overflow = GetFunction(MPFRLibrary, "mpfr_clear_overflow" )
  Global mpfr_clear_divby0.i : mpfr_clear_divby0.mpfr_clear_divby0 = GetFunction(MPFRLibrary, "mpfr_clear_divby0" )
  Global mpfr_clear_nanflag.i : mpfr_clear_nanflag.mpfr_clear_nanflag = GetFunction(MPFRLibrary, "mpfr_clear_nanflag" )
  Global mpfr_clear_inexflag.i : mpfr_clear_inexflag.mpfr_clear_inexflag = GetFunction(MPFRLibrary, "mpfr_clear_inexflag" )
  Global mpfr_clear_erangeflag.i : mpfr_clear_erangeflag.mpfr_clear_erangeflag = GetFunction(MPFRLibrary, "mpfr_clear_erangeflag" )
  Global mpfr_set_underflow.i : mpfr_set_underflow.mpfr_set_underflow = GetFunction(MPFRLibrary, "mpfr_set_underflow" )
  Global mpfr_set_overflow.i : mpfr_set_overflow.mpfr_set_overflow = GetFunction(MPFRLibrary, "mpfr_set_overflow" )
  Global mpfr_set_divby0.i : mpfr_set_divby0.mpfr_set_divby0 = GetFunction(MPFRLibrary, "mpfr_set_divby0" )
  Global mpfr_set_nanflag.i : mpfr_set_nanflag.mpfr_set_nanflag = GetFunction(MPFRLibrary, "mpfr_set_nanflag" )
  Global mpfr_set_inexflag.i : mpfr_set_inexflag.mpfr_set_inexflag = GetFunction(MPFRLibrary, "mpfr_set_inexflag" )
  Global mpfr_set_erangeflag.i : mpfr_set_erangeflag.mpfr_set_erangeflag = GetFunction(MPFRLibrary, "mpfr_set_erangeflag" )
  Global mpfr_clear_flags.i : mpfr_clear_flags.mpfr_clear_flags = GetFunction(MPFRLibrary, "mpfr_clear_flags" )
  Global mpfr_underflow_p.i : mpfr_underflow_p.mpfr_underflow_p = GetFunction(MPFRLibrary, "mpfr_underflow_p" )
  Global mpfr_overflow_p.i : mpfr_overflow_p.mpfr_overflow_p = GetFunction(MPFRLibrary, "mpfr_overflow_p" )
  Global mpfr_divby0_p.i : mpfr_divby0_p.mpfr_divby0_p = GetFunction(MPFRLibrary, "mpfr_divby0_p" )
  Global mpfr_nanflag_p.i : mpfr_nanflag_p.mpfr_nanflag_p = GetFunction(MPFRLibrary, "mpfr_nanflag_p" )
  Global mpfr_inexflag_p.i : mpfr_inexflag_p.mpfr_inexflag_p = GetFunction(MPFRLibrary, "mpfr_inexflag_p" )
  Global mpfr_erangeflag_p.i : mpfr_erangeflag_p.mpfr_erangeflag_p = GetFunction(MPFRLibrary, "mpfr_erangeflag_p" )
  Global mpfr_set_prec_raw.i : mpfr_set_prec_raw.mpfr_set_prec_raw = GetFunction(MPFRLibrary, "mpfr_set_prec_raw" )
  Global mpfr_eq.i : mpfr_eq.mpfr_eq = GetFunction(MPFRLibrary, "mpfr_eq" )
  Global mpfr_reldiff.i : mpfr_reldiff.mpfr_reldiff = GetFunction(MPFRLibrary, "mpfr_reldiff" )
  Global mpfr_mul_2exp.i : mpfr_mul_2exp.mpfr_mul_2exp = GetFunction(MPFRLibrary, "mpfr_mul_2exp" )
  Global mpfr_div_2exp.i : mpfr_div_2exp.mpfr_div_2exp = GetFunction(MPFRLibrary, "mpfr_div_2exp" )
  Global mpfr_custom_get_size.i : mpfr_custom_get_size.mpfr_custom_get_size = GetFunction(MPFRLibrary, "mpfr_custom_get_size" )
  Global mpfr_custom_init.i : mpfr_custom_init.mpfr_custom_init = GetFunction(MPFRLibrary, "mpfr_custom_init" )
  Global mpfr_custom_init_set.i : mpfr_custom_init_set.mpfr_custom_init_set = GetFunction(MPFRLibrary, "mpfr_custom_init_set" )
  Global mpfr_custom_get_kind.i : mpfr_custom_get_kind.mpfr_custom_get_kind = GetFunction(MPFRLibrary, "mpfr_custom_get_kind" )
  Global mpfr_custom_get_significand.i : mpfr_custom_get_significand.mpfr_custom_get_significand = GetFunction(MPFRLibrary, "mpfr_custom_get_significand" )
  Global mpfr_custom_get_exp.i : mpfr_custom_get_exp.mpfr_custom_get_exp = GetFunction(MPFRLibrary, "mpfr_custom_get_exp" )
  Global mpfr_custom_move.i : mpfr_custom_move.mpfr_custom_move = GetFunction(MPFRLibrary, "mpfr_custom_move" )
Else
  Debug "MPFR library not found"
  End
EndIf
; IDE Options = PureBasic 5.31 (Windows - x64)
; CursorPosition = 3
; EnableXP